#include <cstdio>
#include<cmath>
#include <climits>
#include<vector>
#define inf 1e+100
#define nmax 1210

using namespace std;

vector<pair<int,double> > lv[nmax];

int n,m,nh=0;
int t[nmax],h2[nmax],iheap[nmax];
double d[nmax],h1[nmax],x[nmax],y[nmax];
char viz[nmax];

double dist(int i,int j)
{
    return sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
}

void push(double val,int nod)
{
    ++nh;
    h1[nh]=val;
    h2[nh]=nod;
    iheap[nod]=nh;
    int nodc=nh;
    while(nodc/2 && h1[nodc]<h1[nodc/2])
    {
        swap(h1[nodc],h1[nodc/2]);
        swap(h2[nodc],h2[nodc/2]);
        swap(iheap[h2[nodc]],iheap[h2[nodc/2]]);
        nodc/=2;
    }
}

void pop(int &k,double &cost)
{
    cost=h1[1];k=h2[1];
    iheap[k]=0;
    swap(h1[1],h1[nh]);
    swap(h2[1],h2[nh]);
    nh--;
    iheap[h2[1]]=1;
    int nodc=1,fiu;
    while(1)
    {
        if(nodc>nh)break;
        fiu=2*nodc;
        if(fiu>nh)break;
        if(fiu+1<=nh && h1[fiu]>h1[fiu+1])fiu++;
        if(h1[nodc]<h1[fiu])break;
        swap(h1[nodc],h1[fiu]);
        swap(h2[nodc],h2[fiu]);
        swap(iheap[h2[nodc]],iheap[h2[fiu]]);
        nodc=fiu;
    }
}

void update_heap(int nod,double cost)
{
    int nodc=iheap[nod];
    h1[nodc]=cost;
    while(nodc/2 && h1[nodc]<h1[nodc/2])
    {
        swap(h1[nodc],h1[nodc/2]);
        swap(h2[nodc],h2[nodc/2]);
        swap(iheap[h2[nodc]],iheap[h2[nodc/2]]);
        nodc/=2;
    }

}

int main()
{
    FILE *f=fopen("curent.in","r");
    FILE *g=fopen("curent.out","w");
    fscanf(f,"%d",&n);
    int i,j;
    double dd;
    for(i=1;i<=n;i++)
        fscanf(f,"%lf%lf",&x[i],&y[i]);
    for(i=1;i<n;i++)
        for(j=i+1;j<=n;j++)
        {
            dd=dist(i,j);
            lv[i].push_back(make_pair(j,dd));
            lv[j].push_back(make_pair(i,dd));
        }
    vector < pair<int,double> >::iterator it;
    d[1]=0;viz[1]=1;
    for(i=2;i<=n;i++)d[i]=inf;
    for(it=lv[1].begin();it!=lv[1].end();it++)
        {
            d[it->first]=it->second;
            t[it->first]=1;
        }
    for(i=2;i<=n;i++)
            push(d[i],i);
    int k;
    double cost,capm=0;
    for(i=2;i<=n;i++)
    {
        pop(k,cost);viz[k]=1;
        capm+=cost;
        for(it=lv[k].begin();it!=lv[k].end();it++)
            if(!viz[it->first]&&it->second < d[it->first])
            {
                d[it->first]=it->second;
                update_heap(it->first,it->second);
                t[it->first]=k;
            }
    }
    fprintf(g,"%lf\n",capm);
    return 0;
}
